## multipath-tools 0.5.0+git1.656f8865

=== Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#

#
# Try to supply the linux kernel headers.
#
ifeq    ($(KRNLSRC),)
KRNLLIB = /lib/modules/$(shell uname -r)
ifeq    ($(shell test -r $(KRNLLIB)/source && echo 1),1)
KRNLSRC = $(KRNLLIB)/source
KRNLOBJ = $(KRNLLIB)/build
else
KRNLSRC = $(KRNLLIB)/build
KRNLOBJ = $(KRNLLIB)/build
endif
endif
export KRNLSRC
export KRNLOBJ

BUILDDIRS = \
	libmultipath \
	libmultipath/prioritizers \
	libmultipath/checkers \
	libmpathpersist \
	multipath \
	multipathd \
	mpathpersist \
	kpartx

ifeq   ($(MULTIPATH_VERSION),)
VERSION = $(shell basename ${PWD} | cut -d'-' -f3)
else
VERSION = $(MULTIPATH_VERSION)
endif

all: recurse

recurse:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir BUILD=$(BUILD) VERSION=$(VERSION) \
		KRNLSRC=$(KRNLSRC) KRNLOBJ=$(KRNLOBJ) || exit $?; \
	done

recurse_clean:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir clean || exit $?; \
	done

recurse_install:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir install || exit $?; \
	done

recurse_uninstall:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir uninstall || exit $?; \
	done

clean:	recurse_clean
	rm -f multipath-tools.spec
	rm -rf rpms

install:	recurse_install

uninstall:	recurse_uninstall

.PHONY:	TAGS
TAGS:
	etags -a libmultipath/*.c
	etags -a libmultipath/*.h
	etags -a multipathd/*.c
	etags -a multipathd/*.h

release:
	sed -e "s/__VERSION__/${VERSION}/" \
	multipath-tools.spec.in > multipath-tools.spec

rpm: release
	rpmbuild -bb multipath-tools.spec

=== kpartx/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

CFLAGS += -I. -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64

LIBDM_API_COOKIE = $(shell grep -Ecs '^[a-z]*[[:space:]]+dm_task_set_cookie' /usr/include/libdevmapper.h)

ifneq ($(strip $(LIBDM_API_COOKIE)),0)
	CFLAGS += -DLIBDM_API_COOKIE
endif

LDFLAGS = -ldevmapper
OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o dasd.o sun.o \
       gpt.o mac.o ps3.o crc32.o lopart.o xstrncpy.o devmapper.o
EXEC = kpartx

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install: $(EXEC) $(EXEC).8
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) -m 755 kpartx_id $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)/etc/udev/rules.d
	$(INSTALL_PROGRAM) -m 644 kpartx.rules $(DESTDIR)/etc/udev/rules.d/
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm -f $(DESTDIR)$(bindir)/$(EXEC)
	rm -f $(DESTDIR)$(mandir)/$(EXEC).8.gz
	rm -f $(DESTDIR)$(libudevdir)/kpartx_id

clean:
	rm -f core *.o $(EXEC) *.gz

=== libmpathpersist/Makefile ===
# Makefile
#
BUILD = glibc
include ../Makefile.inc

INSTALL_PROGRAM = install

SONAME=0
DEVLIB = libmpathpersist.so
LIBS = $(DEVLIB).$(SONAME)


CFLAGS += -I$(multipathdir) -I$(mpathpersistdir) 
LIBDEPS +=  -lpthread -ldevmapper -ldl -L$(multipathdir) -lmultipath

OBJS = mpath_persist.o mpath_updatepr.o mpath_pr_ioctl.o 

all: $(LIBS)


$(LIBS): 
	$(CC) -Wall -fPIC -c $(CFLAGS) *.c 
	$(CC)  -shared $(LIBDEPS) -Wl,-soname=$@ $(CFLAGS) -o $@ $(OBJS)
	ln -s $(LIBS) $(DEVLIB)
	$(GZIP) mpath_persistent_reserve_in.3 > mpath_persistent_reserve_in.3.gz	
	$(GZIP) mpath_persistent_reserve_out.3 > mpath_persistent_reserve_out.3.gz	

install: $(LIBS)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(man3dir)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)/usr/include/
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)/usr/share/doc/mpathpersist/
	ln -sf $(DESTDIR)$(syslibdir)/$(LIBS) $(DESTDIR)$(syslibdir)/$(DEVLIB)
	install -m 644 mpath_persistent_reserve_in.3.gz $(DESTDIR)$(man3dir)	
	install -m 644 mpath_persistent_reserve_out.3.gz $(DESTDIR)$(man3dir)	
	install -m 644 mpath_persist.h $(DESTDIR)/usr/include/

uninstall:
	rm -f $(DESTDIR)$(syslibdir)/$(LIBS)
	rm $(DESTDIR)$(man3dir)/mpath_persistent_reserve_in.3.gz	
	rm $(DESTDIR)$(man3dir)/mpath_persistent_reserve_out.3.gz	

clean:
	rm -f core *.a *.o 
	rm -f libmpathpersist.so.0
	rm -f libmpathpersist.so
	rm -f mpath_persistent_reserve_in.3.gz mpath_persistent_reserve_out.3.gz

=== libmultipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

SONAME=0
DEVLIB = libmultipath.so
LIBS = $(DEVLIB).$(SONAME)
LIBDEPS = -lpthread -ldl -ldevmapper -ludev
ifdef SYSTEMD
	ifeq ($(shell test $(SYSTEMD) -gt 209 && echo 1), 1)
		LIBDEPS += -lsystemd
	else
		LIBDEPS += -lsystemd-daemon
	endif
endif

OBJS = memory.o parser.o vector.o devmapper.o callout.o \
       hwtable.o blacklist.o util.o dmparser.o config.o \
       structs.o discovery.o propsel.o dict.o \
       pgpolicies.o debug.o defaults.o uevent.o \
       switchgroup.o uxsock.o print.o alias.o log_pthread.o \
       log.o configure.o structs_vec.o sysfs.o prio.o checkers.o \
       lock.o waiter.o file.o wwids.o prioritizers/alua_rtpg.o

LIBDM_API_FLUSH = $(shell grep -Ecs '^[a-z]*[[:space:]]+dm_task_no_flush' /usr/include/libdevmapper.h)

ifneq ($(strip $(LIBDM_API_FLUSH)),0)
	CFLAGS += -DLIBDM_API_FLUSH -D_GNU_SOURCE
endif

LIBDM_API_COOKIE = $(shell grep -Ecs '^[a-z]*[[:space:]]+dm_task_set_cookie' /usr/include/libdevmapper.h)

ifneq ($(strip $(LIBDM_API_COOKIE)),0)
	CFLAGS += -DLIBDM_API_COOKIE
endif

LIBUDEV_API_RECVBUF = $(shell grep -Ecs '^[a-z]*[[:space:]]+udev_monitor_set_resolve_buffer_size' /usr/include/libudev.h)

ifneq ($(strip $(LIBUDEV_API_RECVBUF)),0)
	CFLAGS += -DLIBUDEV_API_RECVBUF
endif

ifdef SYSTEMD
	CFLAGS += -DUSE_SYSTEMD=$(SYSTEMD)
endif

LIBDM_API_DEFERRED = $(shell grep -Ecs '^[a-z]*[[:space:]]+dm_task_deferred_remove' /usr/include/libdevmapper.h)

ifneq ($(strip $(LIBDM_API_DEFERRED)),0)
	CFLAGS += -DLIBDM_API_DEFERRED
endif

all: $(LIBS)

$(LIBS): $(OBJS)
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -Wl,-soname=$@ $(CFLAGS) -o $@ $(OBJS) $(LIBDEPS)
	ln -sf $@ $(DEVLIB)

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(libdir)

uninstall:
	rm -f $(DESTDIR)$(syslibdir)/$(LIBS)

clean:
	rm -f core *.a *.o *.gz *.so *.so.*

=== mpathpersist/Makefile ===
# Makefile
#
include ../Makefile.inc

OBJS = main.o 

CFLAGS += -I$(multipathdir) -I$(mpathpersistdir) 
LDFLAGS += -lpthread -ldevmapper -L$(mpathpersistdir) -lmpathpersist -L$(multipathdir) -lmultipath -ludev

EXEC = mpathpersist

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) -g $(OBJS) -o $(EXEC) $(LDFLAGS) $(CFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	
install:
	install -d $(DESTDIR)$(bindir)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	install -d $(DESTDIR)$(mandir)
	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)
	
clean:
	rm -f *.o $(EXEC)
	rm -f mpathpersist.8.gz

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)
	rm $(DESTDIR)$(mandir)/$(EXEC).8.gz

=== multipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

OBJS = main.o

CFLAGS += -I$(multipathdir)
LDFLAGS += -lpthread -ldevmapper -ldl -L$(multipathdir) -lmultipath -ludev

EXEC = multipath

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	$(GZIP) $(EXEC).conf.5 > $(EXEC).conf.5.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(udevrulesdir)
	$(INSTALL_PROGRAM) -m 644 11-dm-mpath.rules $(DESTDIR)$(udevrulesdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).rules $(DESTDIR)$(libudevdir)/rules.d/56-multipath.rules
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(man5dir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).conf.5.gz $(DESTDIR)$(man5dir)

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)
	rm $(DESTDIR)$(udevrulesdir)/11-dm-mpath.rules
	rm $(DESTDIR)$(libudevdir)/rules.d/56-multipath.rules
	rm $(DESTDIR)$(mandir)/$(EXEC).8.gz
	rm $(DESTDIR)$(man5dir)/$(EXEC).conf.5.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== multipathd/Makefile ===
EXEC = multipathd

include ../Makefile.inc

#
# basic flags setting
#
CFLAGS += -I$(multipathdir) -I$(mpathpersistdir)
ifdef SYSTEMD
	CFLAGS += -DUSE_SYSTEMD=$(SYSTEMD)
endif
LDFLAGS += -lpthread -ldevmapper -lreadline
ifdef SYSTEMD
	ifeq ($(shell test $(SYSTEMD) -gt 209 && echo 1), 1)
		LDFLAGS += -lsystemd
	else
		LDFLAGS += -lsystemd-daemon
	endif
endif
LDFLAGS += -ludev -ldl \
	-L$(multipathdir) -lmultipath -L$(mpathpersistdir) -lmpathpersist

#
# debuging stuff
#
#CFLAGS += -DLCKDBG
#CFLAGS += -D_DEBUG_
#CFLAGS += -DLOGDBG

#
# object files
#
OBJS = main.o pidfile.o uxlsnr.o uxclnt.o cli.o cli_handlers.o


#
# directives
#
all : $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) -o $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(rcdir)
ifdef SYSTEMD
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(unitdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).service $(DESTDIR)$(unitdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).socket $(DESTDIR)$(unitdir)
endif
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm -f $(DESTDIR)$(bindir)/$(EXEC)
	rm -f $(DESTDIR)$(rcdir)/$(EXEC)
	rm -f $(DESTDIR)$(mandir)/$(EXEC).8.gz
	rm -f $(DESTDIR)$(unitdir)/$(EXEC).service
	rm -f $(DESTDIR)$(unitdir)/$(EXEC).socket

clean:
	rm -f core *.o $(EXEC) *.gz

=== libmultipath/prioritizers/Makefile ===
# Makefile
#
# Copyright (C) 2007 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../../Makefile.inc

LIBS = \
	libpriorandom.so \
	libprioconst.so \
	libpriohp_sw.so \
	libprioemc.so \
	libpriordac.so \
	libprioalua.so \
	libprioontap.so \
	libpriodatacore.so \
	libpriohds.so \
	libprioweightedpath.so \
	libprioiet.so

CFLAGS += -I..

all: $(LIBS)

libprioalua.so: alua.o alua_rtpg.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^

libprio%.so: %.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^

install: $(LIBS)
	$(INSTALL_PROGRAM) -m 755 libprio*.so $(DESTDIR)$(libdir)

uninstall:
	for file in $(LIBS); do rm -f $(DESTDIR)$(libdir)/$$file; done

clean:
	rm -f core *.a *.o *.gz *.so

=== debian/changelog ===
multipath-tools (0.5.0+git1.656f8865-5ubuntu2) xenial; urgency=medium

  [ Mauricio Faria de Oliveira ]
  * Remove partition device nodes of individual paths (for LVM on multipath)
    on the new multipath-tools with udev property blacklisting (LP: #1540401)
    - debian/multipath-tools.dm-mpath-lvm.udev: replace 'multipath -c' with
      'multipath -u' which can read udev properties at PROGRAM-rule time
      (when udev properties are not yet written to the udev database).
    - debian/initramfs/init-top: start multipathd before udev (required by
      'multipath -u' in the udev rules)
    - debian/initramfs/local-top: remove snippet to start multipathd.
  * Remove debian/initramfs/local-top (redundant with other initramfs scripts):
    - init-top: start multipathd.
    - init-top: load modules (dm-multipath and SCSI device handlers); move the
      missing dm-emc there (now scsi-dh-emc; see BTS 567014).
    - local-premount: settle on udev events; and the extra call due to
      multipath discovery in udev rules is no longer required with multipathd
      in initramfs.
    - debian/rules: do not install local-top anymore.
  * debian/initramfs/local-premount: run multipath with -B so not to assign
    names nor change /etc/multipath/bindings during initramfs (LP: #1561103)
  * debian/patches/enable-find-multipaths.patch: re-enable find_multipaths
    by default -- see the removed 'add_find-multipaths.patch' (LP: #1463046) 

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 04 Apr 2016 22:36:48 -0400

multipath-tools (0.5.0+git1.656f8865-5ubuntu1) xenial; urgency=medium

  * Merge from Debian. (LP: #1551952) (LP: #1540407)
    Remaining changes:
    - debian/control:
      - Bump debhelper dependency to install udev rules to
        /lib/udev/rules.d
      - Bump udev dependencies as well
    - debian/control:
      - multipath-tools: add sg3-utils-dev Depends
      - multipath-udeb: add sg3-udeb Depends
    - debian/initramfs/hooks: use 95 not 60 for multipath rules priority
    - debian/rules: Move udev rules to priority 95, because rules that load modules should be >90.
    - debian/multipath-tools.preinst: modprobe dm-multipath.
      This will make sure that multipathd will be able to start.
    - debian/initramfs/local-top: wait for udev to settle before running
      'multipath' in order to avoid race condition on device-mapper calls.
    - debian/initramfs/local-top: remove '--timeout 10' which causes my
      test system to not boot roughly 3 out of 4 times.
    - Split kpartx initramfs bits into kpartx-boot for dmraid (LP: #941874)
      - debian/initramfs/kpartx.hook
      - debian/kpartx-boot.postinst
      - debian/kpartx-boot.postrm
      - debian/kpartx.install
      - debian/control: Add kpartx-boot package for dmraid
      - debian/rules: Install kpartx initramfs hook
    - debian/patches/1000--set-umask-in-multipathd.patch: Set umask in multipathd.
    - debian/patches/handle_spaces_in_rev_attr.patch: support IBM IPR devices
      and others which may have only spaces for the rev attribute.
    - debian/patches/path_selector.patch: switch the default path selector
      back to round-robin while service-time isn't available to the installer
      multipath-modules.
    - debian/patches/0015-shared-lock-for-udev.patch: (LP: #1431650)
    - debian/initramfs/hooks: also copy wwids file on the installed system to
      ensure all paths come up on boot. (LP: #1479929)
    - Disable -fexceptions on multipath-udeb (LP: #1489379): the flag causes
      libchecktur.so to link with libgcc_s.so.1 (even with -static-libgcc),
      which is not available in the installer environment.
      - debian/patches/disable-fexceptions-udeb.patch: conditionally disable
        -fexceptions with CFLAGS_DISABLE_FEXCEPTIONS.
      - debian/rules: set CFLAGS_DISABLE_FEXCEPTIONS to build multipath-udeb.
    - debian/patches/handle_spaces_in_rev_attr.patch: update patch to apply the
      change to the right line (LP: #1492425)
    - debian/initramfs/local-premount: wait for udev to settle before the call
      to resolve_device() in local_mount_root(), so the by-uuid/ symlinks have
      a chance to be updated by the multipath udev rules (LP: #1503286).
    - debian/multipath-tools.postinst: handle upgrades from < 0.5.0 by migrating
      from the old device names with device numbers to using letters for devices.
    - debian/patches/mpath_name_migration.patch: ship a multipath_migrate binary
      to make translation from pre-0.5.0 device naming to the new scheme.
    - debian/initramfs/hooks: install multipathd and required directories.
    - debian/initramfs/local-premount: reload all maps to make sure they're
      indeed loaded and ready before we end premount.
    - debian/initramfs/local-top: run multipathd rather than a one-off call to
      multipath so that new paths can be correctly added as detected while we're
      still in the initramfs.
    - debian/initramfs/local-bottom: remember to stop multipathd.
    - debian/rules: install debian/initramfs/local-bottom
    - debian/patches/0053-readonly-bindings_multipathd_prod.patch: support -B to
      allow multipathd to handle cases where the bindings file is read-only.
      (LP: #1526984)
    - debian/patches/git-kpartx-support-spaces-in-dev-names-b407050a.patch: deal
      with spaces in device names in kpartx too (LP: #1432062)
    - debian/tests/kpartx-file-loopback: add an autopkgtest to catch future cases
      where uploads might break kpartx's loopback file handling.
    - debian/patches/kpartx_more_loopback_fixes.patch: fix loopback mounted
      files some more: since we stat() the loopback device node, we can't rely
      on S_ISREG() tests to handle this case, and should look at the device
      itself instead. (LP: #1543430)
    - Remove partition device nodes of individual paths (for LVM on multipath)
      (LP: #1540401)
      - debian/multipath-tools.dm-mpath-lvm.udev: udev rule for that.


=== debian/control ===
Source: multipath-tools
Section: admin
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>
Uploaders: Guido Günther <agx@sigxcpu.org>, Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper (>= 7.0.17ubuntu2), po-debconf, libdevmapper-dev (>= 2:1.02.20), libreadline-dev, libaio-dev, libsystemd-dev, systemd, dh-systemd
Vcs-Git: git://anonscm.debian.org/pkg-lvm/multipath-tools.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-lvm/multipath-tools.git
Standards-Version: 3.9.6
Homepage: http://christophe.varoqui.free.fr/

Package: multipath-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), kpartx (>= ${binary:Version}), lsb-base (>= 3), libaio1 (>= 0.3.106-8), sg3-utils-udev
Breaks: multipath-tools-initramfs (<= 1.0.1),
 multipath-tools-boot (<= 0.4.8+git0.761c66f-2~)
Suggests: multipath-tools-boot
Description: maintain multipath block device access
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.

Package: multipath-tools-dbg
Architecture: any
Section: debug
Depends: ${misc:Depends}, multipath-tools (= ${binary:Version}), kpartx (= ${binary:Version})
Description: maintain multipath block device access - debugging symbols
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.
 .
 This package includes the debugging symbols

Package: kpartx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), dmsetup (>= 2:1.02.24)
Replaces: multipath-tools (<< 0.4.7-3)
Description: create device mappings for partitions
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

Package: kpartx-boot
Architecture: all
Depends: ${misc:Depends}, initramfs-tools,
 kpartx (>= ${source:Version}), kpartx (<< ${source:Version}.1~)
Description: Provides kpartx during boot
 This package makes kpartx availible during boot to activate partitions

Package: multipath-tools-boot
Architecture: all
Depends: ${misc:Depends}, initramfs-tools, 
 multipath-tools (>= ${source:Version}), multipath-tools (<< ${source:Version}.1~),
 kpartx-boot (= ${binary:Version})
Replaces: multipath-tools-initramfs (<< 1.0.1+nmu1)
Breaks: multipath-tools-initramfs (<< 1.0.1+nmu1)
Description: Support booting from multipath devices
 This package contains the necessary support for booting from a multipath
 device:
 .
  * copy over multipath.conf and persistent bindings if necessary
  * load the necessary kernel modules
  * detect multipath block devices
 .
 Don't install this package if you're not booting from a multipath device.

Package: multipath-udeb
Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, multipath-modules, kpartx-udeb, sg3-udeb
Section: debian-installer
Description: maintain multipath block device access - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.

Package: kpartx-udeb
Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: debian-installer
Description: create device mappings for partitions - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

=== debian/rules ===
#!/usr/bin/make -f

INITRAMFS=$(CURDIR)/debian/multipath-tools-boot/usr/share/initramfs-tools/

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
        INSTALL_PROGRAM = install -s
else
        INSTALL_PROGRAM = install
endif

# Work around misp(el) linker bug:
# http://sources.redhat.com/bugzilla/show_bug.cgi?id=10144
DEB_HOST_ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)
ifneq (,$(findstring mips,$(DEB_HOST_ARCH)))
  OPTFLAGS = "OPTFLAGS=-pipe -Wall -Wunused -Wstrict-prototypes"
endif

# For Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
#

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-arch build-indep

build-arch: build-multipath-udeb-stamp build-stamp
build-indep: 

build-stamp:
	dh_testdir
	
	[ ! -f kpartx/kpartx.rules ] || cp kpartx/kpartx.rules debian/kpartx.udev

	$(MAKE) $(OPTFLAGS) LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1

	touch $@

# multipath-udeb: build separately; don't reference dynamic libgcc at runtime (#779579)
build-multipath-udeb-stamp:
	dh_testdir

	DEB_CFLAGS_MAINT_APPEND="-static-libgcc" CFLAGS_DISABLE_FEXCEPTIONS=1 $(MAKE) $(OPTFLAGS) LIB=lib USE_SYSTEMD=0
	
	# store files for install target
	mkdir -p $(CURDIR)/debian/tmp-multipath-udeb/sbin
	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp-multipath-udeb LIB=/lib USE_SYSTEMD=0

	touch $@

clean-tree:
	$(MAKE) clean

clean: clean-tree
	dh_testdir
	rm -f build-stamp build-multipath-udeb-stamp
	dh_prep
	debconf-updatepo
	rm -rf debian/*.debhelper.log
	rm -rf debian/tmp-multipath-udeb

install-indep:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# initramfs stuff:
	install -D -m 755 debian/initramfs/hooks $(INITRAMFS)/hooks/multipath
	install -D -m 755 debian/initramfs/kpartx.hook $(CURDIR)/debian/kpartx-boot/usr/share/initramfs-tools/hooks/kpartx
	install -D -m 755 debian/initramfs/local-premount \
		$(INITRAMFS)/scripts/local-premount/multipath
	install -D -m 755 debian/initramfs/local-bottom \
		$(INITRAMFS)/scripts/local-bottom/multipath
	install -D -m 755 debian/initramfs/init-top \
		$(INITRAMFS)/scripts/init-top/multipath
	# reportbug:
	for pkg in "multipath-tools" "multipath-tools-boot"; do \
	    install -D -m 755 debian/reportbug/script debian/$${pkg}/usr/share/bug/$${pkg}/script; \
	done


install: install-indep
	dh_testdir
	dh_testroot
	dh_installdirs

	mkdir -p $(CURDIR)/debian/tmp/sbin
	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1
	install -m 755 debian/dmsetup_env $(CURDIR)/debian/tmp/lib/udev/
	dh_install -X.rules --fail-missing -Nmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp
	dh_install -Xkpartx_id -X.rules -X.service -X.socket --fail-missing -pmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp-multipath-udeb

binary-indep: build-indep install-indep

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
	dh_lintian
	dh_installinit -pmultipath-tools
	dh_installinit -pmultipath-tools --name=multipath-tools-boot --no-start -- start 21 S .
	dh_installudev -pkpartx --priority=95
	dh_installudev -pmultipath-tools --name=dm-mpath-lvm --priority=56
	dh_installdebconf -pmultipath-tools-boot
	dh_installman
	dh_makeshlibs --add-udeb=multipath-udeb
	dh_link
	dh_strip --dbg-package=multipath-tools-dbg
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary:	binary-indep binary-arch
.PHONY: binary binary-arch binary-indep unpack configure build clean

=== debian/tests/control ===

Tests: kpartx-file-loopback
Depends: kpartx, qemu-utils, gdisk
Restrictions: needs-root

## multipath-tools 0.6.4

=== debian/changelog ===
multipath-tools (0.6.4-5+deb9u1) stretch; urgency=medium

  [ Chris Hofstaedtler ]
  * Apply patch to avoid deadlock in udev triggers, based on upstream
    10704bae99cdcc809aaba0546017cb2eb416c551, with adaptions from
    Alban Browaeys <prahal@yahoo.com> for 0.6.
    (Closes: #859157)
  * Add myself to Uploaders:.

  [ Ritesh Raj Sarraf ]
  * Use tracker as maintainer email address
  * Switch packaging repository to Salsa (Closes: #899615)

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 23 Jul 2018 06:16:34 +0000

multipath-tools (0.6.4-5) unstable; urgency=medium

  * Ship multipath udev rules (Closes: #858456)
  * Define some priority for rules processing

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 25 Mar 2017 15:03:08 +0530

multipath-tools (0.6.4-4) unstable; urgency=medium

  [ Ritesh Raj Sarraf ]
  * [65ba796] Fix path for udevadm, which now resides in /bin.
    Thanks to Michael Biebl (Closes: #852586)
  * [5291947] Drop non-existent dm-emc module and include
    dm-round-robin, in initramfs.
    Thanks to Allan Jacobsen (Closes: #855585)

  [ Christian Ehrhardt ]
  * [6159c78] debian/control: Bump to an updated udev dependency
  * [8649315] debian/tests/kpartx-file-loopback: test kpartx
  * [137dcc1] add Test using tgt and open-iscsi

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 20 Feb 2017 19:36:31 +0530

multipath-tools (0.6.4-3) unstable; urgency=medium

  * [3eecdba] Include libmpathcmd.so in the udeb package.
    Thanks to Allan Jacobsen (Closes: #852431)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 25 Jan 2017 14:58:53 +0530

multipath-tools (0.6.4-2) unstable; urgency=medium

  * [98a45ae] Add a break against multipath-tools, which now doesn't
    provide the file. Thanks to Andreas Beckmann (Closes: #850772)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 23 Jan 2017 13:31:59 +0530

multipath-tools (0.6.4-1) unstable; urgency=medium

  * [bb9b6bf] New upstream version 0.6.4
  * [40f9200] Add patch to cross build from source.
    Thanks to Helmut Grohne (Closes: #845746)
  * [35c91d3] Refresh patches
  * [fbe794c] Add lsb-base to Depends for multipath-tools-boot

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 09 Dec 2016 15:30:50 +0530

multipath-tools (0.6.3-2) unstable; urgency=medium

  * [6915af9] Add patch to disable linking to librados in udeb
    (Closes: #840157)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 09 Oct 2016 14:39:08 +0530

multipath-tools (0.6.3-1) unstable; urgency=medium

  * [e562899] Update debian/gbp.conf for upstream tag
  * [06f6fed] New upstream version 0.6.3
  * [c064fd4] Refresh some patches
  * [91d2497] Add librados-dev to build depends
  * [fe064a4] Update Vcs url to cgit
  * [03f2435] Add full versioned dependency on lsb-base. Thanks lintian

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 08 Oct 2016 23:46:04 +0530

multipath-tools (0.6.2-2) unstable; urgency=medium

  * Upload to Unstable 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 04 Aug 2016 17:34:29 +0530

multipath-tools (0.6.2-1) experimental; urgency=medium

  * [c1c5c8c] Fix manpage about updated kpartx output.
    Thanks to Joey Hess (Closes: #796948)
  * [622958b] Document behavior of aio-max-nr.
    Thanks to Andrew Patterson (Closes: #827322)
  * [91ae9e0] Switch back to using pristine-tar
  * [0403d08] Imported Upstream version 0.6.2
    (Closes: #829496, #830882, #831985)
  * [2022378] Refresh patches and drop patches that are merged upstream
  * [9bf63b9] Add liburcu-dev to build dependency
  * [8e2db83] Update library install list
  * [6adda96] Drop FAQ. Removed Upstream
  * [10936fc] Bump Standards Version to 3.9.8

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 23 Jul 2016 14:15:18 +0530

multipath-tools (0.6.1-3) unstable; urgency=medium

  * Upload to Unstable 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 10 Jun 2016 13:10:18 +0530

multipath-tools (0.6.1-2) experimental; urgency=medium

  * [f59f6c1] Bump debhelper version to 9
  * [7b3bc71] Drop -dbg package in favor of automatic dbgsym packages
  * [c761232] Add patch to fix build failures with unit values on
    some architectures

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 01 Jun 2016 17:07:27 +0530

multipath-tools (0.6.1-1) experimental; urgency=medium

  * New upstream release
  * [80ec942] Refresh patches. And drop disable-blk-availability.patch
    Fixed upstream

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 31 May 2016 17:15:04 +0530

multipath-tools (0.5.0+git1.656f8865-9) unstable; urgency=medium

  * [41dd269] Add remove condition in prerm script.
    Thanks to Andreas Beckmann (Closes: #820031)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 05 Apr 2016 21:51:14 +0530

multipath-tools (0.5.0+git1.656f8865-8) unstable; urgency=medium

  * [ff52e14] Cleanup the breakage introduced in -6 build
    (Closes: #818036, #818293)
  * [2861458] Fix Vcs-Git URL

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 16 Mar 2016 14:58:20 +0530

multipath-tools (0.5.0+git1.656f8865-7) unstable; urgency=medium

  * [72c07f4] Fix kpartx depending of non-existent service.
    Thanks to Michael Biebl (Closes: 818036)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 15 Mar 2016 13:35:08 +0530

multipath-tools (0.5.0+git1.656f8865-6) unstable; urgency=medium

  * [c791eeb] Restrict architecture to linux-any because
    multipath-tools is a Linux only tool
  * [a7baa90] Build binary independent deb package in respective target.
    Thanks to Santiago Vila (Closes: #806082)
  * [1d35c3c] Fix insecure URIs
  * [bfc44fb] Install -boot init script in correct package
  * [76cd8dc] Separate m-t-b's lintian overrides
  * [715ff28] Add separate lintian overrides for m-t-b
  * [7d81d4f] Call clean target before rebuilding with systemd support.
    Thanks to Ryan Harper (Closes: #817940)
  * [5156f96] Make build cleaner for reproducible builds.
    Thanks to Santiago Vila
  * Also close other bugs fixed by this release
    (Closes: #814625, #817147)
  * [9922d0a] Hand install multipath-tools-boot lintian override file


=== debian/control ===
Source: multipath-tools
Section: admin
Priority: extra
Maintainer: Debian DM Multipath Team <team+linux-blocks@tracker.debian.org>
Uploaders: Guido Günther <agx@sigxcpu.org>, Ritesh Raj Sarraf <rrs@debian.org>, Chris Hofstaedtler <zeha@debian.org>
Build-Depends: debhelper (>= 9), po-debconf, libdevmapper-dev (>= 2:1.02.20), libreadline-dev, libaio-dev, dpkg-dev (>= 1.16.1~), libudev-dev, libsystemd-dev, systemd, dh-systemd, liburcu-dev, librados-dev
Vcs-Git: https://salsa.debian.org/linux-blocks-team/multipath-tools.git
Vcs-Browser: https://salsa.debian.org/linux-blocks-team/multipath-tools.git
Standards-Version: 3.9.8
Homepage: http://christophe.varoqui.free.fr/

Package: multipath-tools
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), kpartx (>= ${binary:Version}), lsb-base (>= 3.0-6), libaio1 (>= 0.3.106-8), sg3-utils-udev
Breaks: multipath-tools-initramfs (<= 1.0.1),
 multipath-tools-boot (<= 0.4.8+git0.761c66f-2~)
Suggests: multipath-tools-boot
Description: maintain multipath block device access
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.

Package: kpartx
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), dmsetup (>= 2:1.02.24)
Replaces: multipath-tools (<< 0.4.7-3)
Description: create device mappings for partitions
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

Package: multipath-tools-boot
Architecture: all
Depends: ${misc:Depends}, initramfs-tools, lsb-base (>= 3.0-6),
 multipath-tools (>= ${source:Version}), multipath-tools (<< ${source:Version}.1~)
Replaces: multipath-tools-initramfs (<< 1.0.1+nmu1), multipath-tools (<< 0.5.0+git1.656f8865-6)
Breaks: multipath-tools-initramfs (<< 1.0.1+nmu1), multipath-tools (<< 0.5.0+git1.656f8865-6)
Description: Support booting from multipath devices
 This package contains the necessary support for booting from a multipath
 device:
 .
  * copy over multipath.conf and persistent bindings if necessary
  * load the necessary kernel modules
  * detect multipath block devices
 .
 Don't install this package if you're not booting from a multipath device.

Package: multipath-udeb
Package-Type: udeb
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, multipath-modules, kpartx-udeb
Section: debian-installer
Description: maintain multipath block device access - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.

Package: kpartx-udeb
Package-Type: udeb
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: debian-installer
Description: create device mappings for partitions - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

=== debian/rules ===
#!/usr/bin/make -f

INITRAMFS=$(CURDIR)/debian/multipath-tools-boot/usr/share/initramfs-tools/

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
        INSTALL_PROGRAM = install -s
else
        INSTALL_PROGRAM = install
endif

# Work around misp(el) linker bug:
# http://sources.redhat.com/bugzilla/show_bug.cgi?id=10144
DEB_HOST_ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)
ifneq (,$(findstring mips,$(DEB_HOST_ARCH)))
  OPTFLAGS = "OPTFLAGS=-pipe -Wall -Wunused -Wstrict-prototypes"
endif

# For Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
#

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-arch build-indep

build-arch: build-multipath-udeb-stamp build-stamp
build-indep:
	# Nothing to do here.
	touch $@

build-stamp: clean-tree
	dh_testdir
	
	[ ! -f kpartx/kpartx.rules ] || cp kpartx/kpartx.rules debian/kpartx.udev
	[ ! -f multipath/multipath.rules ] || cp multipath/multipath.rules debian/multipath.udev
	[ ! -f multipath/11-dm-mpath.rules ] || cp multipath/11-dm-mpath.rules debian/dm-mpath.udev

	dh_auto_build -- $(OPTFLAGS) LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1 USE_RADOS=1

	touch $@

# multipath-udeb: build separately; don't reference dynamic libgcc at runtime (#779579)
build-multipath-udeb-stamp:
	dh_testdir

	DEB_CFLAGS_MAINT_APPEND="-static-libgcc" dh_auto_build -- $(OPTFLAGS) LIB=/lib USE_SYSTEMD=0 USE_RADOS=0
	
	# store files for install target
	mkdir -p $(CURDIR)/debian/tmp-multipath-udeb/sbin
	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp-multipath-udeb LIB=/lib USE_SYSTEMD=0 USE_RADOS=0

	touch $@

clean-tree:
	$(MAKE) clean

clean: clean-tree
	dh_testdir
	rm -f build-stamp build-multipath-udeb-stamp
	dh_prep
	debconf-updatepo
	rm -rf debian/*.debhelper.log
	rm -rf debian/tmp-multipath-udeb

install-indep:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# initramfs stuff:
	install -D -m 755 debian/initramfs/hooks $(INITRAMFS)/hooks/multipath
	install -D -m 755 debian/initramfs/local-top \
		$(INITRAMFS)/scripts/local-top/multipath
	install -D -m 755 debian/initramfs/init-top \
		$(INITRAMFS)/scripts/init-top/multipath

	# reportbug:
	for pkg in "multipath-tools" "multipath-tools-boot"; do \
	    install -D -m 755 debian/reportbug/script debian/$${pkg}/usr/share/bug/$${pkg}/script; \
	done

	# lintian override
	install -D -m 644 debian/multipath-tools-boot.lintian-overrides \
	    debian/multipath-tools-boot/usr/share/lintian/overrides/multipath-tools-boot


install: install-indep
	dh_testdir
	dh_testroot
	dh_installdirs

	mkdir -p $(CURDIR)/debian/tmp/sbin
	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1 USE_RADOS=1
	install -m 755 debian/dmsetup_env $(CURDIR)/debian/tmp/lib/udev/
	dh_install -X.rules --fail-missing -Nmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp
	dh_install -Xkpartx_id -X.rules -X.service -X.socket --fail-missing -pmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp-multipath-udeb

binary-indep: build-indep install-indep
	dh_testdir -i
	dh_testroot -i
	dh_installdirs -i
	dh_installchangelogs -i
	dh_installdocs -i
	dh_installexamples -i
	dh_installinit -pmultipath-tools-boot --name=multipath-tools-boot --no-start -- start 21 S .
	dh_installinit -pmultipath-tools-boot
	dh_installdebconf -pmultipath-tools-boot
	dh_installman -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a
	dh_lintian -a
	dh_systemd_enable -pmultipath-tools multipathd.service
	dh_installinit -pmultipath-tools
	dh_installudev -pkpartx
	dh_installudev -pmultipath-tools --name=multipath
	dh_installudev -pmultipath-tools --name=dm-mpath --priority=11
	dh_link -a lib/systemd/system/multipathd.service \
		lib/systemd/system/multipath-tools.service
	dh_systemd_start -pmultipath-tools multipathd.service
	dh_installman -a
	dh_makeshlibs -a --add-udeb=multipath-udeb
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary:	binary-indep binary-arch
.PHONY: binary binary-arch binary-indep unpack configure build clean
